package prodcons;

import java.util.Observable;
import java.util.Random;

public class Producent extends Observable implements Runnable {

    public static enum State {

        WRITING, PRODUCTING;
        private int value;

        public void setValue(int value) {
            this.value = value;
        }

        public int getValue() {
            return value;
        }
    }
    private State state;
    private Buffer sharedLocation;
    private Random generator = new Random();

    public Producent(Buffer shared) {
        sharedLocation = shared;
    }

    public void run() {
        while (true) {
            int doba = 1000 + generator.nextInt(5000);
            updateState(State.PRODUCTING, doba);
            try {
                Thread.sleep(2000 + generator.nextInt(3000));
            } catch (InterruptedException e) {
            }
            updateState(State.WRITING, 0);
            sharedLocation.set(doba);
        }
    }

    private void updateState(State state, int value) {
        state.setValue(value);
        this.state = state;
        setChanged();
        notifyObservers();
    }

    public State getState() {
        return state;
    }
}
